# Inference in the Cloud

Concrete ML models can be easily deployed in a client/server setting, enabling the creation of privacy-preserving services in the cloud.

As seen in the [concepts section](/concrete-ml/1.1/getting-started/concepts.md), once compiled to FHE, a Concrete ML model generates machine code that performs the inference on private data. *Secret* encryption keys are needed so that the user can securely encrypt their data and decrypt the inference result. An *evaluation* key is also needed for the server to securely process the user's encrypted data.

Keys are generated by the user *once* for each service they use, based on the model the service provides and its cryptographic parameters.

The overall communications protocol to enable cloud deployment of machine learning services can be summarized in the following diagram:

![](/files/jgsadFu9zx7c5um2dsB3)

The steps detailed above are:

1. The model developer deploys the compiled machine learning model to the server. This model includes the cryptographic parameters. The server is now ready to provide private inference.
2. The client requests the cryptographic parameters (also called "client specs"). Once it receives them from the server, the *secret* and *evaluation* keys are generated.
3. The client sends the *evaluation* key to the server. The server is now ready to accept requests from this client. The client sends their encrypted data.
4. The server uses the *evaluation* key to securely run inference on the user's data and sends back the encrypted result.
5. The client now decrypts the result and can send back new requests.

For more information on how to implement this basic secure inference protocol, refer to the [Production Deployment section](/concrete-ml/1.1/advanced-topics/client_server.md) and to the [client/server example](https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/docs/advanced_examples/ClientServer.ipynb).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.zama.org/concrete-ml/1.1/getting-started/cloud.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
